from datetime import datetime
from application.app import db
from models.user import UserModel
<<<<<<< HEAD
from webcreator.utils import ResponseCode, response_result
=======
from webcreator.log import logger
from webcreator.response import ResponseCode, response_result
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca

class UserResource(object):
    def __init__(self):
        super().__init__()

<<<<<<< HEAD
    def get(self, params):
        # handle business
        filters = []
        result = UserModel.query.filter(*filters).order_by(UserModel.areaId).paginate(params.get('page', 1), params.get('pageSize', 10), error_out=False)

        return result

    def post(self, params, jwt=None):
        # handle business
        result = UserModel.query.filter(UserModel.areaName == params.get('areaName')).first()
        if result and result.is_delete:
            result.is_delete = False
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
            return response_result(ResponseCode.OK)
        elif result and result.is_delete == False:
            return response_result(ResponseCode.EXISTS_ERROR)
=======
    def get(self, uuid, params):
        # handle business
        filters = [UserModel.is_delete==False, UserModel.uuid==uuid]
        result = UserModel.query.filter(*filters).first()
        if result:
            return (True, result)
        return (False, result)

    def getList(self, params):
        # handle business
        logger.warn(params)
        filters = [UserModel.is_delete==False]
        result = UserModel.query.filter(*filters).order_by(UserModel.create_at).paginate(params.get('page', 1), params.get('pageSize', 10), error_out=False)

        return (True, result.items, result.total)

    def post(self, params, jwt={}):
        # handle business
        result = UserModel.query.filter(UserModel.app_name == params.get('app_name')).first()
        if result and result.is_delete:
            result.is_delete = False
            result.update_by = jwt.get("id", "")
            result.update_date = datetime.now()
            db.session.commit()
            return (True, None)
        elif result and result.is_delete == False:
            return (False, "record code exists")
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca

        result = UserModel(**params)
        db.session.add(result)
        db.session.commit()
<<<<<<< HEAD
        return response_result(ResponseCode.OK)

    def put(self, id, params, jwt=None):
        # handle business
        result = UserModel.query.get(id)
        if not result: return response_result(ResponseCode.NO_DATA)
        if params:
            for key, value in params.items():
                if value != None: setattr(result, key, value)
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
        else:
            return response_result(ResponseCode.PARAM_NULL)

    def delete(self, id, jwt=None):
        # handle business
        result = UserModel.query.get(id)
        if not result: return response_result(ResponseCode.NO_DATA_FOUND)
        else:
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            result.is_delete = True
            db.session.delete(result)
            db.session.commit()
=======
        return (True, None)

    def put(self, uuid, params, jwt={}):
        # handle business
        result = UserModel.query.filter(UserModel.uuid==uuid).first()
        if not result:
            return (False, "record not exists")

        if params:
            for key, value in params.items():
                if value != None: setattr(result, key, value)
            result.update_by = jwt.get("id", "")
            result.update_date = datetime.now()
            db.session.commit()
            return (True, None)
        else:
            return (False, "params is null")

    def delete(self, uuid, jwt={}):
        # handle business
        result = UserModel.query.filter(UserModel.uuid==uuid).first()
        if not result:
            return (False, "record not exists")

        result.update_by = jwt.get("id", "")
        result.update_date = datetime.now()
        result.is_delete = True
        db.session.delete(result)
        db.session.commit()
        return (True, None)
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca

userManager = UserResource()